用法: 在CAD的命令行中输入Appload或点击工具--加载应用程序,打开加载/卸载对话框,把zz.lsp文件复制到已打开的文件夹中,选择下载的附件文件,然后点击内容--加载--选中文件--点击关闭即可,文件名是ZZ,点击加载/关闭即可。在CAD命令行中输入ZZ,选择要统计线段长度的所有线段,结果马上出来。

 

;;;-----------------------------------------------------
;;;计算线加总长度
;;;-----------------------------------------------------
(defun C:zz (/ CURVE TLEN SS N SUMLEN)
(vl-load-com)
(setq SUMLEN 0)
(setq SS (ssget '((0 . "CIRCLE,ELLIPSE,LINE,*POLYLINE,SPLINE,ARC"))))
(setq N 0)
(repeat (sslength SS)
(setq CURVE (vlax-ename->vla-object (ssname SS N)))
(setq TLEN (vlax-curve-getdistatparam
CURVE
(vlax-curve-getendparam CURVE)
)
)
(setq SUMLEN (+ SUMLEN TLEN))
(setq N (1+ N))
)
(print (strcat "总长度: " (rtos SUMLEN 2 5)))
(princ)
)